/* la fonction de teste pour tester les fonctions */

#include "graphes.h"
#include "tp1.h"


#define NB_AL 10 /* nombre de fois où l'on fait les testes aléatoires invisibles */






/* pour libérer la mémoire alloué à un graphe en liste d'adjacence */
GrapheListe freeGrapheListe(GrapheListe G) {
 if (G==NULL) return(NULL) ;
 int i;
 int n=G->nb_sommets;
 ListeAdj L,c;
 for(i=0;i<n;i++) {
  c=G->Adj[i];
  while(c!=NILL) {L=c->suivant; free(c); c=L; }
 }
 free(G);
 return(NULL) ;
}



/* idem pour les graphes en matrice d'adjacence */
GrapheMatr freeGrapheMatr(GrapheMatr H) {
 if (H==NULL) return(NULL) ;
 int i;
 int n=H->nb_sommets;
 int **T=H->Matr;
 for(i=0;i<n;i++) free(T[i]);
 free(H);
 return(NULL) ;
}





int main (void) {

  GrapheListe G1, G2 ;
  GrapheMatr H ;
  int *d ;
  int i ;
  int a, b ;
  char S[100] ;


  printf("TEST AFFICHAGE G1\n");
  G1 = lireGrapheListe("./G1");
  afficheGrapheListe(G1);
  printf("\ndeuxième essai :\n");
  afficheGrapheListe(G1);
  freeGrapheListe(G1);

  printf("\nTEST AFFICHAGE ALÉATOIRE PETIT\n");
  G1 = grapheListeAleatoire(8,20,5,0);
  afficheGrapheListe(G1);
  freeGrapheListe(G1);

  printf("\nTEST AFFICHAGE ALÉATOIRE GROS\n");
  G1 = grapheListeAleatoire(40,1000,5,1);
  afficheGrapheListe(G1);
  freeGrapheListe(G1);

  printf("\n\nTEST CONVERSION G1\n");
  G1 = lireGrapheListe("./G1");
  printf("avant :\n");
  afficheGrapheListe(G1);
  H = listeVersMatrice(G1);
  freeGrapheListe(G1);
  G1 = matriceVersListe(H);
  freeGrapheMatr(H);
  printf("\naprès :\n");
  afficheGrapheListe(G1);
  freeGrapheListe(G1);

  printf("\nTEST CONVERSION GROS\n");
  G1 = grapheListeAleatoire(100,5000,5,1);
  H = listeVersMatrice(G1);
  freeGrapheListe(G1);
  G1 = matriceVersListe(H);
  printf("...\n");
  freeGrapheMatr(H);
  freeGrapheListe(G1);

  printf("\n\nTEST TRANSPOSE G1\n");
  G1 = lireGrapheListe("./G1");
  G2 = transpose(G1);
  afficheGrapheListe(G2);
  freeGrapheListe(G1);
  freeGrapheListe(G2);

  printf("\nTEST TRANSPOSE ALÉATOIRE GROS\n");
  G1 = grapheListeAleatoire(100,5000,5,1);
  G2 = transpose(G1);
  printf("...\n");
  freeGrapheListe(G1);
  freeGrapheListe(G2);


  printf("\n\nTEST PARCOURS G2 (ARBRE)\n");
  G1 = lireGrapheListe("./G2");
  G2 = parcoursLargeur(G1);
  afficheGrapheListe(G2);
  freeGrapheListe(G1);
  freeGrapheListe(G2);

  printf("\nTEST PARCOURS G2-tr (ARBRE À L'ENVERS)\n");
  G1 = lireGrapheListe("./G2-tr");
  G2 = parcoursLargeur(G1);
  afficheGrapheListe(G2);
  freeGrapheListe(G1);
  freeGrapheListe(G2);

  printf("\nTEST PARCOURS ALÉATOIRE GROS\n");
  G1 = grapheListeAleatoire(100,5000,5,1);
  G2 = parcoursLargeur(G1);
  printf("...\n");
  freeGrapheListe(G1);
  freeGrapheListe(G2);

  printf("\n\nTEST DISTANCES G3\n");
  G1 = lireGrapheListe("./G3");
  d = distances(G1, 0);
  for (i=0 ; i<10 ; i++) printf("  d(%i,%i) = %i\n", 0, i, d[i]);
  printf("d(4,3) = %i (normalement 2)\n" , distance(G1,4,3));
  printf("d(3,2) = %i (normalement 2)\n" , distance(G1,3,2));
  printf("d(5,3) = %i (normalement -1)\n" , distance(G1,5,3));
  freeGrapheListe(G1);
  free(d);

  printf("\nTEST DISTANCES ALÉATOIRE GROS\n");
  G1 = grapheListeAleatoire(100,1000,5,1);
  d = distances(G1, 0);
  for(i=0; i<50; i++) printf("  d(0,%i) = %i , d(%i,0) = %i\n", i, d[i], i, distance(G1,i,0));
  freeGrapheListe(G1);
  free(d);

  printf("\n\nTEST DIAMETRE G4\n");
  G1 = lireGrapheListe("./G4");
  i = diametre(G1, &a, &b);
  printf("  diametre = %i de %i à %i\n", i, a, b);
  freeGrapheListe(G1);

  printf("\nTEST DIAMETRE GROS\n");
  G1 = grapheListeAleatoire(100,5000,5,1);
  i = diametre(G1, &a, &b);
  printf("  diametre = %i\n", i);
  freeGrapheListe(G1);

  printf("\n\nTEST LABYRINTHE\n");
  G1 = labyrintheRect(10,10);
  d = resoudLabyrinthe(G1, 0, 90);
  for (i=0;i<100;i++) S[i] = ' ';
  S[0] = '@' ; S[90] = '$' ;
  afficheGrilleRect(G1,10,10,S);
  afficheChemin(d, 0, 90);

  int depart = 0;
  int arrivee = 90;
  G1 = labyrintheHex(10,10);
  d = resoudLabyrinthe(G1, depart, arrivee);
  char *T = transformePere(G1, d,arrivee,depart);
  afficheGrilleHex(G1,10,10,T);



 return(0) ;
}

