/**********************************************************************
 ***** Pierre Hyvernat, cours info505 "Algorithmes de graphes"    *****
 *****                                                            *****
 ***** Ce fichier contient les prototypes de toutes les fonctions *****
 ***** que vous devrez définir.                                   *****
 *********************************************************************/

#ifndef _tp1_H
#define _tp1_H





/* Q1 : prototype de la fonction d'affichage */
void afficheGrapheListe (const GrapheListe) ;


/* Q2 : prototytpes des fonctions de conversion */
GrapheMatr listeVersMatrice(const GrapheListe) ;
GrapheListe matriceVersListe(const GrapheMatr) ;


/* Q3 : prototype de la fonction qui renverse tous les arcs. */
GrapheListe transpose(const GrapheListe) ;


/* Q4 : prototype du parcours en largeur */
GrapheListe parcoursLargeur (GrapheListe G) ;


/* Q5 : prototype de la fonction qui calcule la distance entre a et b */
int *distances(GrapheListe G, int a) ;
int distance(GrapheListe G, int a, int b) ;


/* Q6 (bonus) : prototype de la fonction qui calcule le diametre d'un graphe et donne
 * deux sommets eloignés dans a et b
 */
int diametre(const GrapheListe G, int *a, int *b);


/* Q7 : prototype de la fonction pour résoudre un labyrinthe donné par un
 * graphe. */
int* resoudLabyrinthe(GrapheListe G, int entree, int sortie) ;
void afficheChemin(int *pere, int entree, int sortie) ;


/* Q8 : prototype de la fonction qui transforme le tableau "pere" en un
 * tableau utilisable par les fonctions d'affichages des grilles
 * rectangulaires ou hexagonales.*/
char *transformePere(GrapheListe G, int *pere, int a, int b) ;



#endif  /* _tp1_H */
